var VKAppControl = new Class({
	element: null,
	id: '',
	classes: '',
	value: '',
	label: '',
	selected: false,
	disabled: false,
	width: 110,
	bool: false,
	events: {},
	readonly: true,

	extraElements: [],

	highlightEvent: 'mouseover',
	unhighlightEvent: 'mouseout',
	activateEvent: 'click',
	//deactivateEvent: 'click',

	initialize: function(settings)
	{
		settings = settings || {};
		Object.each(settings, function(value, key){this[key] = value;}.bind(this));

		//this.element.setStyle('cursor', 'pointer');
	},
	GetValue: function()
	{
		if(this.bool)
		{
			return this.selected;
		}
		else
		{
			return this.value;
		}
	},
	OnEvent: function(event, action)
	{
		if(typeOf(this.events[event]) != 'array')
		{
			this.events[event] = [];
		}

		this.events[event].push(action);
	},
	ApplyUserEvents: function()
	{
		//el = el || this.element;
		Object.each(this.events, function(actions, event){
			actions.each(function(action){
				this.element.addEvent(event, function(){return action(this.value, this.id)}.bind(this));
			}, this);
		}, this);
	},
	ApplySystemEvents: function()
	{
		this.extraElements.combine([this.element]).each(function(element)
		{
			element.addEvent(this.highlightEvent, function(e)
			{
				this.Highlight();
			}.bind(this));

			element.addEvent(this.unhighlightEvent, function(e)
			{
				this.Unhighlight();
			}.bind(this));

			element.addEvent(this.activateEvent, function(e)
			{
				if(this.bool)
				{
					this.selected = !this.selected;

					if(this.selected)
					{
						this.Activate();
						this.Highlight();
					}
					else
					{
						this.Deactivate();
						this.Unhighlight();
					}

				}
				else
				{
					this.selected = true;
					this.Activate();
					this.Highlight();
				}
			}.bind(this));
			/*
			element.addEvent(this.deactivateEvent, function(e)
			{
			this.Deactivate();
			this.selected = false;
			}.bind(this));
			*/
		}.bind(this));
	},
	Get: function()
	{
		if(this.element != null)
		{
			return this.element;
		}

		this.element = this.BuildElement();

		if(this.selected == null || !this.selected)
		{
			this.Deactivate();
			this.Unhighlight();
		}
		else
		{
			this.Activate();
			//console.log('mouse over');
			//this.Highlight(); //Why does the element needs to be highlighted??
		}

		this.element.id = this.id;

		this.ApplySystemEvents();
		this.ApplyUserEvents();

		return this.element;
	},
	GetLabel: function()
	{
		var text = this.label || this.value;

		if(text)
		{
			var el = new Element('span', {'class':'label'});

			el.set('text', text);

			el.addEvent('click', function(){this.element.fireEvent('click')}.bind(this));
			el.addEvent('mouseover', function(){this.element.fireEvent('mouseover')}.bind(this));
			el.addEvent('mouseout', function(){this.element.fireEvent('mouseout')}.bind(this));

			//el.setStyle('cursor', 'pointer');

			return el;
		}
		else
		{
			return false;
		}
	},
	BuildElement: function()
	{
		console.error('BuildElement() method not found');
		return new Element('div');
	},
	OnChange: function()
	{
	},
	//Generic actions
	Highlight: function()
	{
	},
	Unhighlight: function()
	{
	},
	Activate: function()
	{
	},
	Deactivate: function()
	{
	}
});