var VKAppControlSelect = new Class({
	Extends: VKAppControlsCollection,
	itemClass: 'VKAppControlSelectItem',
	bool: true,
	SetValue: function(value)
	{
		Slick.find(this.element, 'input').set('value', value);
	},
	BuildElement: function()
	{
		//Field element
		var element = new Element('div');
		element.setStyle('white-space', 'nowrap');

		var input = new Element('input');
		input.setStyle('width', this.width);
		input.set('readonly', this.readonly);

		//Set up suggestions
		if(!this.readonly)
		{
			input.addEvent('keyup', function(){this.FilterControls(input)}.bind(this));
			input.addEvent('blur', function()
			{
				var validValue = false;

				this.controls.each(function(control)
				{
					if(control.value == input.value)
					{
						validValue = true;
					}
				});

				if(!validValue)
				{
					input.value = this.GetValue();
				}
			}.bind(this));
		}

		input.set('value', this.value);

		var arrow = new Element('div', {'class':'list_drop_arrow'});

		var field = new Element('div', {'class':'list_field'});
		field.adopt(input);
		field.adopt(arrow);

		element.adopt(field);

		//Element list
		var list = new Element('ul', {'class': 'list_items'});
		this.controls.each(function(control){
			list.adopt(control.Get());
		});

		var shad1 = new Element('div', {'class': 'shadow1'});
		shad1.set('opacity', .12);

		var shad2 = new Element('div', {'class': 'shadow2'});
		shad2.set('opacity', .05);

		var shad = new Element('div', {'class': 'result_list_shadow'});
		shad.adopt(shad1);
		shad.adopt(shad2);

		this.extraElements.push(list);
		this.extraElements.push(shad);

		document.id('body').adopt(list);
		document.id('body').adopt(shad);

		/*
		//Fill select list
		this.controls.each(function(control, key)
		{
		//var controlEl = control.Get();

		controlEl.addEvent(this.activateEvent, function()
		{
		input.set('value', control.value);
		this.current = key;
		}.bind(this));


		//controlEl.addEvent('mouseover', function(){controlEl.addClass('active')}.bind(this));

		//Last one
		if(this.controls.length - 1 == key)
		{
		controlEl.addClass('last');
		}

		list.adopt(controlEl);
		}.bind(this));

		*/

		/*
		field.addEvent('mouseover', function(){arrow.addClass('over')});
		field.addEvent('mouseout', function(){if(list.getStyle('display') == 'none'){arrow.removeClass('over')}});
		*/

		//Handling outer click
		document.addEvent('click', function(e)
		{
			if(e.target != field && !field.contains(e.target))
			{
				//field.style.display != 'none'
				//console.log(input);
				//console.log(e.target);


				//field.fireEvent(field.activateEvent);

				this.Deactivate();
				this.Unhighlight();
				//list.setStyle('display', 'none');
				//shad.setStyle('display', 'none');
				//arrow.removeClass('over');
			}
		}.bind(this));


		return element;
	},
	Highlight: function()
	{
		Slick.find(this.element, 'div.list_drop_arrow').addClass('over');
	},
	Unhighlight: function()
	{
		if(this.extraElements[0].getStyle('display') == 'none')
		{
			Slick.find(this.element, 'div.list_drop_arrow').removeClass('over');
		}
	},
	Activate: function()
	{
		this.selected = true;
		//console.log('Activating');
		var list = this.extraElements[0];
		var shad = this.extraElements[1];

		var field = Slick.find(this.element, 'div.list_field');
		/*
		if(list.getStyle('display') == 'none')
		{*/
		var pos = field.getCoordinates();
		list.setStyles({'top': pos.top + pos.height, 'left': pos.left});
		list.setStyle('width', pos.width);
		list.setStyle('display', 'block');

		var lastVisible = 0;

		//Each item element
		list.getChildren('li').each(function(li, key)
		{
			if(li.getStyle('display') != 'none')
			{
				lastVisible = key;
			}

			this.controls.each(function(control)
			{
				li.removeClass('last');

				if(control.element == li && control.selected == true)
				{
					li.addClass('active');
				}
			});
		}.bind(this));


		list.getChildren('li')[lastVisible].addClass('last')


		var pos = list.getCoordinates();
		shad.setStyles({'top': pos.top + pos.height, 'left': pos.left});
		shad.setStyle('display', 'block');
		shad.setStyle('width', pos.width);
		/*}
		else
		{
		list.setStyle('display', 'none');
		shad.setStyle('display', 'none');
		}*/
	},
	Deactivate: function()
	{
		this.selected = false;
		//console.log('Deactivating');

		var list = this.extraElements[0];
		var shad = this.extraElements[1];

		list.setStyle('display', 'none');
		shad.setStyle('display', 'none');



		//Activate all options
		list.getChildren().each(function(li)
		{
			li.setStyle('display', 'block');
		});

		return false;

		//this.Unhighlight();
	}
});

var VKAppControlSelectItem = new Class
({
	Extends: VKAppControl,
	BuildElement: function()
	{
		var li = new Element('li');
		li.set('text', this.value);
		return li;
	},
	Activate: function()
	{
	},
	Highlight: function()
	{
		this.element.addClass('active');
	},
	Unhighlight: function()
	{
		this.element.removeClass('active')
	}
});