var VKAppControlsCollection = new Class({
	Extends: VKAppControl,
	controls: [],
	multiple: false,
	data: [],
	lastValue: null,
	itemClass: null,
	trapHighlight: false,
	initialize: function(settings)
	{
		this.parent(settings);

		//Import data
		this.controls = this.GetControls();

		//Handle selected items
		var selected = false;

		this.controls.each(function(control)
		{
			if(!this.multiple && selected)
			{
				return false;
			}
			else
			{
				//control.selected = true;
				//selected = true;
			}

		}.bind(this));

		this.lastValue = this.GetValue();
	},
	FilterControls: function(input)
	{
		this.controls.each(function(control)
		{
			if(control.value.contains(input.value) || input.value == '')
			{
				control.Get().setStyle('display', 'block');
			}
			else
			{
				control.Get().setStyle('display', 'none');
			}
		});

		this.Activate();

/*
		//redraw shad position
		var list = this.extraElements[0];
		var shad = this.extraElements[1];
		var pos = list.getCoordinates();
		shad.setStyles({'top': pos.top + pos.height, 'left': pos.left});
		shad.setStyle('display', 'block');*/
	},
	DataSource: function()
	{
		return [];
	},
	GetControls: function()
	{
		var controls = [];

		//Creating controls
		this.data.each(function(settings)
		{
			controls.push(new window[this.itemClass](settings));
		}.bind(this));

		//Applying antiactions
		controls.each(function(control)
		{
			//On highligh
			control.OnEvent(control.highlightEvent, function()
			{
				//unhighlight
				controls.each(function(innerControl)
				{
					//everybody
					if(innerControl != control)
					{
						// else
						innerControl.Unhighlight();
					}
				}.bind(this));
			}.bind(this));


			//Get currently selected items

/*			if(control.selected)
			{
				this.value = control.value;
				//this.SetValue(control.GetValue());
				//console.log();
			}
*/

			/*if(this.maxSelected == 1)
			{*/
			//On activate
			control.OnEvent(control.activateEvent, function()
			{
				//disactivate
				controls.each(function(innerControl)
				{
					//everything
					if(innerControl != control)
					{
						//else
						innerControl.Deactivate();
						innerControl.selected = false;
					}
				}.bind(this));

				var new_value = this.GetValue();

				if(String.from(this.lastValue) != String.from(new_value))
				{
					this.lastValue = new_value;
					this.SetValue(new_value);

					this.OnChange(new_value, this.GetSelectedIds());
				}
			}.bind(this));
			/*}*/
		}.bind(this));

		return controls;
	},
	SetValue: function(value)
	{
	},
	GetSelectedIds: function()
	{
		var ids = [];

		this.controls.each(function(control)
		{
			if(control.selected)
			{
				ids.push(control.id);
			}
		});

		return ids;
	},
	GetValue: function()
	{
		var value = [];

		this.controls.each(function(control)
		{
			if(control.selected)
			{
				value.push(control.value);
			}
		});

		if(this.multiple)
		{
			return value;
		}
		else if(value.length > 0)
		{
			return value[0];
		}
		else
		{
			return '';
		}
	},
	GetId: function()
	{
		var ids = [];

		this.controls.each(function(control)
		{
			if(control.selected)
			{
				ids.push(control.id);
			}
		});

		if(this.multiple)
		{
			return ids;
		}
		else if(ids.length > 0)
		{
			return ids[0];
		}
		else
		{
			return 0;
		}
	},
	Get: function()
	{
		this.parent();

		this.SetValue(this.GetValue());

		return this.element;
	}
});