var VKAppForm = new Class
({
	fields: {},
	request: null,
	submit: null, //submits on every field change if not set
	mainElement: 'mainPanel',
	sideElement: 'sidePanel',
	initialize: function(base)
	{
		//Have request to perform on submit
		if(typeOf(this.request) == 'string')
		{
			this.request = base.GetObject('request' + this.request.capitalize());
		}
	},
	AddField: function(field, name, submit)	//actionParam is used to update server params
	{
		field.OnChange = function()
		{
			if(typeOf(this.request) == 'object')
			{
				this.request.SetParam(name, field.GetId());
			}

			/*
			//No submit button
			if(this.submit == null)
			{
				//autosubmit
				this.Submit();
			}*/
			this.OnChange();
		}.bind(this);

		this.fields[name] = field;

		if(submit == true)
		{
			field.OnEvent(field.activateEvent, function(){this.Submit();}.bind(this));
			this.submit = field;
		}
	},
	GetField: function(name)
	{
		return this.fields[name];
	},
	Submit: function()
	{
		Object.each(this.fields, function(field, name)
		{
			this.request.SetParam(name, field.GetId());
		}.bind(this));

		this.OnSubmit();

		if(this.request != null)
		{
			this.request.Call(null, true);
		}
	},
	GetFieldsElements: function()
	{
		var res = {};

		Object.each(this.fields, function(field, name)
		{
			res[name] = field.Get();
		});

		return res;
	},
	AppendContent : function(content, useSide)
	{
		var target = useSide ? this.sideElement : this.mainElement;

		if(typeOf(content) == 'element')
		{
			document.id(target).adopt(content);
		}
		else
		{
			document.id(target).innerHTML += content;
		}

		this.base.FixHeight();
	},
	OnSubmit: function()
	{
	},
	OnLoad: function()
	{
	},
	OnChange: function()
	{
	},
	Reset: function(target)
	{
		if(typeOf(target) == 'string')
		{
			document.id(target).empty();
		}
		else
		{
			document.id(this.mainElement).empty();
			document.id(this.sideElement).empty();
		}
	}
});