var VKAppFormRelations = new Class({
	Extends: VKAppForm,
	request: 'relations',
	initialize: function(base)
	{
		var filter = new VKAppControlFilter
		({
			data:
			[
			{value:'Прошлые',id: 1, selected: true},
			{value:'Текущие',id: 2},
			{value:'Желаемые',id: 3}
			]
		});
		this.AddField(filter, 'type');


		this.parent(base); //Important. Parent constructor creates request object.
	},

	BuilRelationTypes: function()
	{
		//Apply redirect event and select current relation type
		this.GetField('type').controls.each(function(control)
		{
			//Add redirect event
			control.OnEvent(control.activateEvent, function(value, id)
			{
				this.base.navigation.LoadUrl('relations/'+ this.base.navigation.GetUrlPart(1) + '/' + id);
			}.bind(this));

			//Select if current
			if(this.base.navigation.GetUrlPart(2) == control.id)
			{
				this.GetField('type').controls[0].selected = false;
				control.selected = true;
			}
		}.bind(this));

		this.AppendContent(this.GetField('type').Get(), true);
	},
	BuildUserAvatar: function(selected)
	{

		//Adding current user image
		this.base.GetObject('api').Call('getProfiles', {uids: this.base.navigation.GetUrlPart(1)+'', fields: 'photo_medium'}, function(items)
		{
			var userInfo = new Element('div', {'class':'userInfo'});
			var userImage = new Element('img', {src:items[0].photo_medium, alt: ''});
			userInfo.adopt(userImage);

			/*		Bookmark Bar		*/

			if(this.base.viewer_id != this.base.navigation.GetUrlPart(1))
			{
				var bookmarkIt = new Element('div', {'class': 'bookmark'});
				var check = new VKAppControlCheckbox({selected: selected, label:'Запомнить'});

				check.OnEvent(check.activateEvent, function()
				{
					var req = this.base.GetObject('request');
					req.params = {user: this.GetField('user').GetId(), status: check.selected};
					req.Call('SetUserBookmark');
					req.OnSuccess = function(){}

				}.bind(this));

				var checkLabel = check.GetLabel()

				bookmarkIt.adopt(check.Get());
				bookmarkIt.adopt(checkLabel);
				userInfo.adopt(bookmarkIt);
			}

			/*		Bookmark Bar		*/

			userInfo.inject(document.id('filters_separator'), 'after');

			//this.base.GetObject('request').Call('getUserInfo');

			//Make a decent request. Make separate class. Attach it to the users control?
			//this.base.GetObject('request').params = {type: this.request.params.type, status: this.request.params.status, user: this.request.params.user};
			//this.base.GetObject('request').Call('getUserInfo');
		}.bind(this));
	},
	IsUserBookmarked: function(ids)
	{
		//user himself
		if(this.base.navigation.GetUrlPart(1) == this.base.viewer_id)
		{
			return true;
		}

		//Decide to add current user to the end of the bookmarks or it has already been bookmarked
		var found = false;

		ids.each(function(id)
		{
			if(id == this.base.navigation.GetUrlPart(1))
			{
				found = true;
			}
		}.bind(this));

		return found;
	},

	BuildBookmarksControls: function(userData)
	{
		/*
		//Add current user!
		if(!found)
		{
		userData.push({value:'', id: this.base.navigation.GetUrlPart(1)});
		}*/



		var user = new VKAppControlFilter
		({
			data: userData
		});

		//Deactivate all user elements except for the current user
		user.controls.each(function(control)
		{
			//Add redirect event
			control.OnEvent(control.activateEvent, function(value, id)
			{
				//console.log('relations/'+ this.base.navigation.GetUrlPart(1) + '/' + id);
				this.base.navigation.LoadUrl('relations/'+ id + '/' + this.base.navigation.GetUrlPart(2));
			}.bind(this));

			if(control.id == this.base.navigation.GetUrlPart(1))
			{
				//console.log(control.id + '!');
				control.selected = true;
			}
			else
			{
				control.selected = false;
			}
		}.bind(this));
		this.AddField(user, 'user');
		this.AppendContent(this.GetField('user').Get(), true);

		this.Submit();


	},
	BuildBookmarks: function()
	{
		//By default show only mine
		var userData = [{value:'Мои',id: this.base.viewer_id}];

		//var userData = [];
		var rq = this.base.GetObject('request');
		rq.Call('getUserBookmarks');
		rq.OnSuccess = function(ids)
		{
			var found = this.IsUserBookmarked(ids);

			if(this.base.navigation.GetUrlPart(1) != this.base.viewer_id)
			{
				ids.push(this.base.navigation.GetUrlPart(1));
			}

			//get this person's name
			if(ids.length > 0)
			{
				//ids.push(this.base.navigation.GetUrlPart(1));

				this.base.GetObject('api').Call('getProfiles', {uids: this.base.Implode(ids), fields: 'first_name,nickname', name_case: 'gen'}, function(users)
				{
					users.each(function(user)
					{
						/*
						//Current user
						if(user.uid == this.base.navigation.GetUrlPart(1))
						{
						}
						*/

						userData.push({value: user.first_name,id: user.uid});

					}.bind(this));

					this.BuildUserAvatar(found);
					this.BuildBookmarksControls(userData);

					//this.GetField('user').controls.getLast().Get().set('text', /*items[0].nickname ? items[0].nickname :*/ items[0].first_name );
				}.bind(this));
			}
			//No requests needed
			else
			{
				this.BuildUserAvatar(found);
				this.BuildBookmarksControls(userData);
			}
		}.bind(this);
	},
	OnLoad: function()
	{
		//Clear everything
		this.Reset();

		this.BuilRelationTypes();

		//filters/image separator
		this.AppendContent(new Element('div', {'class':'side_filter_sep', 'id':'filters_separator'}), true);

		//Image/bookmarks separaor
		this.AppendContent(new Element('div', {'class':'side_filter_sep'}), true);

		//Set current page. Control doesn't exists for this, so set it manually.
		this.request.SetParam('status', 1);

		this.BuildBookmarks();

		//Set current user param
		//this.request.SetParam('user', this.base.navigation.GetUrlPart(1));
	}
});