var VKAppNavigation = new Class
({
	currentPage : null,
	currentUrl : '',
	pages: [],
	defaultPage : null,

	initialize : function()
	{
		if(!devMode)
		{
			VK.addCallback('onLocationChanged', function (loc)
			{
				//this.LoadUrl(loc); //Loading from here won't work since current scope is a handler function, so this event has probably fired already.
				//Actually it even blocks the redirect somehow.
				this.base.url = loc; // Instead we set up a property and grab data from there when we're ready.
				//We only use this event to load initial page anyway :p
			}.bind(this));
		}
	},
	GetDefaultPage : function()
	{
		var defaultPage = null;

		this.pages.each(function(item, index)
		{
			if(!defaultPage && item.active && item.menuItem)
			{
				defaultPage = item;
			}
		});

		return defaultPage;
	},
	LoadPages : function(pages)
	{
		var result = [];
		//var self = this;

		pages.each(function(page, i){
			var className = 'VKAppPage' + page.capitalize();

			if(typeOf(window[className]) == 'class')
			{
				result.push(this.base.GetObject('page' + page.capitalize()));
				result.getLast().id = page;
				/*
				result.push(new window[className]);
				result[result.length-1].id = page;
				*/
			}
		}, this);

		/*
		var result = [];

		for(i in window)
		{
		if(/VKAppPage.+/.test(i))
		{
		result.push(new window[i]);
		result[result.length-1].id = i;
		}
		}*/

		this.pages = result;
	},
	LoadUrl : function(url)
	{
		if(url == this.currentUrl && url)
		{
			return false;
		}

		this.base.GetObject('pagination').Reset();
		this.base.GetObject('statusBar').Reset();
		//this.base.GetObject('server').calls = {};

		var oldUrl = url;

		//Deselect all pages
		this.pages.each(function(page)
		{
			page.current = false;
		}, this);

		//Getting blindly page from url / or default one
		this.currentPage = this.GetPageFromUrl(url);

		//Selecting page
		this.currentPage.current = true;

		//Ok, we have a page, now to validate params
		//Validate url
		url = this.GetValidUrl(url);

		if(url == this.currentUrl)
		{
			return false;
		}

		this.currentUrl = url;

		if(url != oldUrl)
		{
			console.log('Loading url "'+oldUrl+'" (redirected: "' + url + '")');
		}
		else
		{
			console.log('Loading url "'+oldUrl+'"');
		}

		this.base.GetObject('menu').SelectPage();

		if(!devMode)
		{
			VK.callMethod("setTitle", this.base.title  + ' | ' + this.currentPage.title);
			VK.callMethod("setLocation", this.currentUrl);
		}

		//this.base.GetObject('pagination').currentPage = 1;

		document.id('mainPanel').empty();
		document.id('sidePanel').empty();

		document.id('mainPanel').erase('class');
		document.id('sidePanel').erase('class');

		var pageClass = this.currentPage.id + 'Page';

		document.id('mainPanel').addClass(pageClass);
		document.id('sidePanel').addClass(pageClass);

		this.base.GetObject('statusBar').Reset();
		//this.base.GetObject('popup').Reset();

		this.currentPage.OnLoad();
		/*
		this.currentPage.LoadMain();
		this.currentPage.LoadSide();
		*/

		//}

		//Setting content
		/*
		document.id('mainPanel').set('html', this.currentPage.GetMainContent());
		document.id('sidePanel').set('html', this.currentPage.GetSideContent());
		*/

		//console.log(document.id('sidePanel').get('html').length);
		/*
		if(!document.id('sidePanel').get('html').length)
		{
		document.id('sidePanel').setStyle('display', 'none');
		document.id('mainPanel').setStyle('border-width', '0');
		}
		else
		{
		document.id('sidePanel').setStyle('display', 'table-cell');
		document.id('mainPanel').setStyle('border-width', '1px');
		}*/

		return true;
	},
	/*LoadMain: function()
	{
	document.id('mainPanel').empty();
	//this.base.GetObject('statusBar').Reset();
	this.currentPage.LoadMain();
	},*/
	BuildUrl : function(url)
	{
		return 'http://vkontakte.ru/app' + this.base.id + '#' + url;
	},
	GetUrlController : function(url)
	{
		if(typeof url !== 'string')
		{
			return '';
		}

		return url.split('/')[0];
	},
	GetPageFromUrl : function(url)
	{
		if(typeof url !== 'string')
		{
			return '';
		}

		var found = this.defaultPage;

		this.pages.each(function(page)
		{
			if(this.GetUrlController(url) == page.id)
			{
				found = page;
			}
		}, this);

		return found;
	},
	GetPageClassName : function(page)
	{
		return 'VKApp' + this.id.capitalize();
	},
	GetUrlParts : function(url)
	{
		return url.split('/');
	},
	GetDefaultUrl : function(page)
	{
		//Replace preg with data from array

		var curParam = 0;
		var resultUrl = [];

		[page.id].append(page.uriPattern).each(function(patternPart)
		{
			if(page.defaultUriParams[curParam].test(patternPart))
			{
				resultUrl.push(page.defaultUriParams[curParam++]);
			}
			else
			{
				resultUrl.push(patternPart);
			}
		});

		return resultUrl.join('/');
	},
	GetValidUrl : function(url)
	{
		//Url is invalid as it can be
		if(typeof url !== 'string' || !url.length)
		{
			return this.GetDefaultUrl(this.defaultPage);
		}

		var oldUrl = url;

		//Building uri params uri from input url, no page name
		var urlParts = this.GetUrlParts(url);
		urlParts = urlParts.slice(1, urlParts.length);
		url = urlParts.join('/');

		var pattern = [];
		//building regexp pattern
		this.currentPage.uriPattern.each(function(item)
		{
			pattern.push(item);
		});

		pattern = '^'+pattern.join('/')+'$';

		//Match! Found! Url is ok.
		if(url.test(pattern) && this.currentPage.ValidateUrlParams(urlParts))
		{
			resultUrl = oldUrl;
		}
		else
		{
			resultUrl = this.GetDefaultUrl(this.currentPage);
		}

		return resultUrl;
	},
	BuildLink : function(title, action, props, styles)
	{
		if(typeof props != 'object')
		{
			var props = {};
		}

		if(typeof styles != 'object')
		{
			var styles = {};
		}

		var a = new Element('a', props);

		a.setProperties(props);
		a.setStyles(styles);

		if(typeOf(title) == 'element')
		{
			a.adopt(title);
		}
		else
		{
			a.set('html', String.from(title));
		}

		if(typeOf(action) == 'string')
		{
			a.setProperty('href', this.BuildUrl(action));

			if(!this.GetPageFromUrl(action).active)
			{
				a.addEvent('click', function(){return false});
			}
			else
			{
				a.addEvent('click', function(){this.LoadUrl(action);return false;}.bind(this));
			}
		}
		else
		{
			a.addEvent('click', action);
		}

		return a;
	},
	GetUrlPart: function(n)
	{
		return this.currentUrl.split('/')[n];
	}
});
