<?php

error_reporting(E_ALL);

header("Expires: Tue, 03 Jul 2001 06:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

abstract class VKServer
{
	private $action = '';
	private $params = array();

	private $result = array();
	private $settings = array();

	protected $error = false;

	protected $limit = 5;
	protected $page = 1;

	protected $totalItems = 0;

	//private $page = 1;

	public function __construct()
	{
		if (!empty($this->error))
		{
			return false;
		}

		//ob_start();
		$params = $_GET;

		if (!isset($_SERVER['HTTP_REFERER']))
		{
			die();
		}

		parse_str($_SERVER['HTTP_REFERER'], $settings);

		$this->settings = $settings;

		if (!isset($params['action']))
		{
			$this->error = 'No action specified';
			return false;
		}

		foreach ($params as &$item)
		{
			$item = $this->Sanitate($item);
		}

		$this->action = $params['action'];
		unset($params['action']);


		if (!isset($params['page']))
		{
			$this->page = 1;
		}
		else
		{
			$this->page = (int)$params['page'];
			unset($params['page']);
		}

		$this->params = $params;

		$this->Call();

		return true;
	}

	public function GetUserId()
	{
		if (empty($this->settings) || !isset($this->settings['viewer_id']))
		{
			return false;
		}
		else
		{
			return (int)$this->settings['viewer_id'];
		}
	}

	public function __destruct()
	{
		if (headers_sent())
		{
			die();
		}

		header('Cache-Control: no-cache, must-revalidate');
		header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
		header('Content-type: application/json');

		if (empty($this->error))
		{
			if(is_array($this->result))
			{
				$this->result = array('data'=>$this->result, 'totalItems'=>$this->totalItems, 'paginationPage'=>$this->page);
			}

			print json_encode($this->result);
		}
		else
		{
			print json_encode(array('error' => $this->error));
		}

		return true;
	}

	public function GetParam($name)
	{
		if (!isset($this->params[$name]))
		{
			return null;
		}
		else
		{
			return $this->params[$name];
		}
	}

	public function Call()
	{
		$method = $this->action . 'Action';

		if (!method_exists($this, $method))
		{
			$this->error = 'Unknown method "' . $this->action.'"';
		}
		else
		{
			$this->result = call_user_func_array(array($this, $method), array($this->params));
		}

		return true;
	}

	abstract protected function Sanitate($str);

	abstract protected function GetPageEventsAction($params);
}