<?php

error_reporting(0);

function getFilesRecursive($folder, $ext)
{
	$path = dirname(__FILE__) . '/' . $folder . '/';
	$res = array();

	$oldPath = $path;

	while (($list = (array)glob($path . '*.'.$ext)) || count(glob($path)))
	{
		$path .= '*/';
		$res = array_merge($res, $list);
	}

	foreach ($res as &$item)
	{
		$item = $folder . '/' . str_replace($oldPath, '', $item);
	}

	return $res;
}

function buildJs($folder)
{
	$res = getFilesRecursive($folder, 'js');

	foreach ($res as &$item)
	{
		$item = '<script src="'.$item.'" type="text/javascript"></script>';
	}

	return implode(PHP_EOL, $res);
}

function buildCss($folder)
{
	$res = getFilesRecursive($folder, 'css');

	foreach ($res as &$item)
	{
		$item = '<link rel="stylesheet" href="'.$item.'" type="text/css" />';
	}

	return implode(PHP_EOL, $res);
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" version="-//W3C//DTD XHTML 1.1//EN" xml:lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
		<title>Test</title>

		<base href="" />
		<!--Стили Вконтакте-->
		<link rel="stylesheet" href="http://vkontakte.ru/css/rustyle.css" type="text/css" />

		<!--Стили приложения-->
		<?php print buildCss('gui'); ?>

		<!--API Вконтакте-->
		<script src="http://vkontakte.ru/js/api/xd_connection.js?2" type="text/javascript"></script>

		<!--Сторонние библиотеки-->
		<?php print buildJs('libs'); ?>

		<!--Классы приложения-->
		<?php print buildJs('classes'); ?>

		<!--Настройки-->
		<script src="settings.js" type="text/javascript"></script>
		<!--Запускаем приложение-->
		<script src="start.js" type="text/javascript"></script>
	</head>

	<body class="pageBody" id="body">

		<div class="popup_screen" id="popup">
			<div class="popup">
				<div class="header">
					<div class="close" id="popupClose"></div>
					<div class="title" id="popupTitle"></div>
				</div>

				<div class="body" id="popupBody"></div>

				<div class="footer" id="popupFooter">
					<div class="progress" id="progressPopup"></div>
					<!--<div class="button_no"><div style="background-color: rgb(234, 234, 234); border-top-color: rgb(255, 255, 255); border-right-color: rgb(244, 244, 244); border-bottom-color: rgb(223, 223, 223); border-left-color: rgb(244, 244, 244); ">Отмена</div></div>
					<div class="button_yes"><div>Добавить</div></div>-->
				</div>
			</div>
		</div>

		<div class="clearFix tBar" id="menubar">
			<ul id="menulist" class="t0"></ul>
		</div>

		<div id="summaryBar" class="bar clearFix summaryBar">
			<div id="summaryBarContent" class="summary">
				<span id="summaryBarTitle"></span>
			</div>
			<div class="fl_r">
				<span id="pagesTop">
					<ul class="pageList" id="pagesTopList"></ul>
				</span>
				<div class="fl_l" id="progressTop">
					<img src="gui/images/upload.gif" />
				</div>
			</div>
		</div>

		<table cellspacing="0" cellpadding="0" height="100%" width="100%" valign="top" id="mainTable">
			<tr>
				<td id="mainPanel" height="100%" align="left" valign="top"></td>
				<td id="sidePanel" height="100%" align="left" valign="top"></td>
			</tr>
		</table>

		<div style="height: 20px;" class="bar clearFix footerBar" id="summaryBarBottom">
			<div class="fl_r">
				<span id="pagesBottom">
					<ul class="pageList" id="pagesBottomList"></ul>
				</span>
				<div class="fl_l" id="progressBottom">
					<img style="vertical-align: baseline;" src="gui/images/upload.gif">
				</div>
			</div>
		</div>

	</body>
</html>