<?php

require('classes/server.class.php');

class Server extends VKServer
{
	private $db;
	//private $limit = 9;

	public function __construct()
	{
		$this->db = new mysqli('localhost', 'root', 'dbroot2', 'vk1');

		$this->error = $this->db->connect_error;
		/*
		if (!empty($this->db->connect_error))
		{

		}*/

		parent::__construct();
	}

	public function Sanitate($str)
	{
		return $this->db->real_escape_string($str);
	}

	public function SetUserBookmarkAction()
	{
		$userId = $this->GetUserId();
		$targetUserId = (int)$this->GetParam('user');

		//Add BM
		if ($this->GetParam('status') == 'true')
		{
			$query = "
INSERT INTO
	bookmarks(user1,user2)
VALUES
	($userId, $targetUserId)
";
		}
		//Delete BM
		else
		{
$query = "
DELETE FROM
	bookmarks
WHERE
	user1 = $userId AND user2 = $targetUserId
";
		}

		$this->db->query($query);

		return true;
	}

	public function GetUserBookmarksAction()
	{
		$userId = $this->GetUserId();

		$query = "
SELECT DISTINCT
	user2 AS id
FROM
	bookmarks
WHERE
	user1 = $userId

";

		$res = $this->db->query($query);

		$ids = array();

		while ($id = $res->fetch_row())
		{
			$ids[] = $id[0];
		}

		$this->totalItems = count($ids);

		return $ids;
	}

	public function GetUserInfoAction()
	{
		$userId = (int)$this->GetParam('user');

		$res = $this->db->query("
SELECT
	ct.url,
	COUNT(c.status) AS num,
	u.sympathy
FROM
	connections c
INNER JOIN
	connection_statuses ct
	ON
	ct.id = c.status
INNER JOIN
	users u
	ON
	u.id = $userId
WHERE
	$userId IN (c.user1, c.user2)
GROUP BY
	c.status
		");

		$users = array();

		while ($row = $res->fetch_assoc())
		{
			$users[$row['url']] = $row['num'];
			$users['sympathy'] = $row['sympathy'];
		}

		$this->totalItems = count($users);

		return $users;
	}

	public function GetRelationsAction()
	{
		$type = $this->GetParam('type');
		$status = $this->GetParam('status');
		$userId = $this->GetParam('user');

		if ($userId == null)
		{
			return array();
		}

		/*
		вытащить все данные о связях пользователя
		Для каждой связи вытащить количество её связей
		*/
		$res = $this->db->query("

SELECT SQL_CALC_FOUND_ROWS
	connections.id,
	IF(user1 = $userId, user2, user1) AS user_id,
	users.sympathy,
	(SELECT COUNT(*) FROM connections c WHERE user_id IN (c.user1, c.user2) AND  status = 1) AS relations,
	(SELECT COUNT(*) FROM connections c WHERE user_id IN (c.user1, c.user2) AND  status = 2) AS rumors

FROM
	connections
INNER JOIN
	users
	ON
	users.id = IF(user1 = $userId, user2, user1)
WHERE
		$userId IN(user1,user2)
		AND
		type= $type
		AND
		status=$status
GROUP BY
	user1,user2
ORDER BY
	users.sympathy
	DESC
LIMIT
	" . ($this->page - 1) * $this->limit . ',' . $this->limit);

		$users = array();

		if (!$res)
		{
			$this->error = $this->db->error;
			return false;
		}

		while ($user = $res->fetch_assoc())
		{
			$users[] = $user;
		}

		$res = $this->db->query("SELECT FOUND_ROWS()");
		$num = $res->fetch_row();
		$this->totalItems = $num[0];

		return $users;
	}

	protected function GetPageEventsAction($params)
	{
		//time_nanosleep(0, (rand(1,9) * 100000000));
		return  (int)rand(0,3);
	}
}

new Server();